program essai
implicit none

integer, parameter :: m=33
double precision :: x(m)
double precision :: y(m)
double precision :: r(m)

integer k,nest,n,inm,iopt,lwrk,ier,i
double precision xb,xe,s,fp,dx
double precision, allocatable, dimension(:) :: w,t,c,wrk
integer, allocatable, dimension(:) :: iwrk

do i=1,33
   y(i)=y(i)+(dble(i-1)/32.d0)**1.234
end do
do i=1,33
   x(i)=dble(i-1)/32.d0
end do
call random_number (r)
r=(r-0.5d0)/100.d0
x(2:32)=x(2:32)+r(2:32)

!   allocate(w(m))

!   k=3
!   s=0.
!   w=1.
!   iopt=0
!   xb=x(1)
!   xe=x(m)
!   nest=m+k+1
!   lwrk=m*(k+1)+nest*(7+3*k)
!   allocate (t(nest))
!   allocate (c(nest))
!   allocate(wrk(lwrk))
!   allocate(iwrk(nest))
!   call curfit(iopt,m,x,y,w,xb,xe,k,s,nest,n,t,c,fp,wrk,lwrk,iwrk,ier)
!      dx=(xe-xb)/real(m-1)
!   do i=1,m
!      x(i)=xb+(i-1)*dx 
!   end do
!   call splev(t,n,c,k,x,y,m,ier)

!====================================================================

do i=1,33
   write (124,*) x(i),y(i)
end do

k=3
call resample (x,y,m,k)

do i=1,33
   write (125,*) x(i),y(i)
end do

end program

!====================================================================
!====================================================================
!====================================================================
!====================================================================



subroutine resample (x,y,m,k)
implicit none
integer m,k
double precision x(m),y(m)

integer nest,n,inm,iopt,lwrk,ier,i
double precision xb,xe,s,fp,dx
double precision, allocatable, dimension(:) :: w,t,c,wrk
integer, allocatable, dimension(:) :: iwrk

allocate(w(m))

k=3
s=0.
w=1.
iopt=0
xb=x(1)
xe=x(m)
nest=m+k+1
lwrk=m*(k+1)+nest*(7+3*k)

allocate (t(nest))
allocate (c(nest))
allocate(wrk(lwrk))
allocate(iwrk(nest))

call curfit(iopt,m,x,y,w,xb,xe,k,s,nest,n,t,c,fp,wrk,lwrk,iwrk,ier)

dx=(xe-xb)/real(m-1)

do i=1,m
   x(i)=xb+(i-1)*dx 
end do

call splev(t,n,c,k,x,y,m,ier)

deallocate(wrk)
deallocate(iwrk)
deallocate(t)
deallocate(c)
deallocate(w)

end subroutine resample
